/*--------------------------------------------------------
   X_APP2.C -- Displays " hh:mm:ss:ff" in client area
  --------------------------------------------------------*/
    //NOTE: WHERE THERE IS A 'WO' IN THE COMMENTS BELOW, IT STANDS FOR
		// 'WINDOWS OVERHEAD'. THE 'WO' CODE HELPS TO DRAW THE
		// WINDOW, UPDATE THE WINDOW, ETC.

#include <windows.h>
#include "aecdll.h"	      //PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS

//VARIABLE DEFINITIONS
char	hhmmssff[11];
int	aecint, aecnum1, aecnum2, ckvltc, ckmmr, ckior;
char	rev[2], AECstrA[2], AECascTB[12], AECascUB[12], AEChhmmssff[12];
WORD	PCTC1, DPRAMaddress, MMR1, IOR1, passed_address;
BYTE	ResetBrd, idleMode, stuffTCgen, runLTCnGEN, startGen, stopGen;
BYTE	GenInt, AEC3fdReg, AEC3feReg, Cmdbyte;
DWORD	AECTB, AECTBE, AECUB, AECREAD4, AECWRITE4, longbyte;
UINT	AECselector;
LPSTR	lpPassToAECDLLrev, lpAEChhmmssff;     /* typedef char FAR* LPSTR */
LPSTR	lpAECascTB, lpAECascUB, lpAECstrA;
LPWORD	lpAECselector, lpPCTC1, lpMMR1, lpIOR1, lpDPRAMaddress; /* typedef word FAR* LPWORD */
LPBYTE	lpResetBrd, lpidleMode, lpstuffTCgen, lprunLTCnGEN;
LPBYTE	lpstartGen, lpstopGen;
LPBYTE	lpGenInt, lpAEC3fdReg, lpAEC3feReg, lpCmdbyte;
LPDWORD lpAECTB, lpAECTBE, lpAECUB, lpAECREAD4, lpAECWRITE4;//dword FAR* DWORD

long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;
	    /*window proceedure (WndProc) PROTOTYPE*/
/************************************************************************/

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
    {
    static char szAppName[] = "TIME CODE" ;			// WO
    HWND	 hwnd ; 					// WO
    WNDCLASS	 wndclass ;					// WO
    MSG		 msg;						// WO

    lpPassToAECDLLrev = rev;		   // set and initialize variables
    lpAECascTB = AECascTB;				   //
    lpAECascUB = AECascUB;				   //
    lpAECstrA  = AECstrA;				   //
    lpAEChhmmssff = AEChhmmssff;			   //
    lpAECselector = &AECselector;			   //
    PCTC1  =  0xCC00;		// PCTC Board base address
    lpPCTC1 = &PCTC1;					   //
    lpCmdbyte = &Cmdbyte;
    MMR1 = 0xC800;
    lpMMR1 = &MMR1;
    IOR1 = 0x02A0;
    lpIOR1 = &IOR1;
    ResetBrd	 = 0x02;	// PCTC command codes
    idleMode	 = 0x20;		  //
    stuffTCgen	 = 0x41;		  //
    runLTCnGEN	 = 0x25;		  //
    startGen	 = 0x48;		  //
    stopGen	 = 0x49;		  //
    GenInt   = 0x04;					    //
    lpResetBrd	 = &ResetBrd;				    //
    lpidleMode	 = &idleMode;				    //
    lpstuffTCgen = &stuffTCgen; 			    //
    lprunLTCnGEN = &runLTCnGEN; 			    //
    lpstartGen	 = &startGen;				    //
    lpstopGen	 = &stopGen;				    //
    lpDPRAMaddress = &DPRAMaddress;			    //
    lpGenInt	= &GenInt;				    //
    lpAEC3fdReg = &AEC3fdReg;				    //
    lpAEC3feReg = &AEC3feReg;				    //
    lpAECTB	= &AECTB;				    //
    lpAECTBE	= &AECTBE;				    //
    lpAECUB	= &AECUB;				    //
    lpAECREAD4	= &AECREAD4;				    //
    lpAECWRITE4 = &AECWRITE4;				    //
    AECWRITE4	= 0x23583512; //'Hex' STUFF GEN DATA 23:59:05:12 HH:MM:SS:FF

    if (!hPrevInstance) // WO used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		// WO
	  wndclass.lpfnWndProc	 = WndProc ;				// WO
	  wndclass.cbClsExtra	 = 0 ;					// WO
	  wndclass.cbWndExtra	 = 0 ;					// WO
	  wndclass.hInstance	 = hInstance ;				// WO
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	// WO
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	// WO
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	// WO
	  wndclass.lpszMenuName  = NULL ;				// WO
	  wndclass.lpszClassName = szAppName ;				// WO

	  RegisterClass (&wndclass) ;					// WO
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "TC DLL Demo",		     // window text
		    WS_THICKFRAME | WS_SYSMENU,	     // window style
		    0x100, //CW_USEDEFAULT,	     // initial x position
		    0x180, //CW_USEDEFAULT,	     // initial y position
		    0x100, //CW_USEDEFAULT,	     // window width
		    0x60, //CW_USEDEFAULT,	     // window height
                    NULL,                    // parent window handle
                    NULL,                    // window menu handle
                    hInstance,               // program instance handle
		    NULL) ;		     // creation parameters
    ShowWindow (hwnd, nCmdShow) ;	// WO part of the window creation
    UpdateWindow (hwnd) ;		// WO part of the window creation

      aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev); //get the DLL rev.
	// THE FOLLOWING CODE BLOCK INITIALIZES THE BOARD AND STARTS THE GEN
      AEC_PCTC_GET_SELECTOR(lpAECselector, lpPCTC1); // put the board's selector
		//  in data word at the address pointed to by the far pointer
      AEC_PCTC_SEND_COMMAND(lpResetBrd, lpAECstrA, lpPCTC1); // resets board
      AEC_PCTC_SEND_COMMAND(lpidleMode, lpAECstrA, lpPCTC1); //send idle code
      DPRAMaddress = 0x0040;  //*sets the time that gen will use when started
      AEC_PCTC_WRITE_4BYTES(lpAECWRITE4, lpDPRAMaddress, lpPCTC1);
      DPRAMaddress = 0x03F0;	// sets tc generator frame change interupt
      AEC_PCTC_WRITE_1BYTE(lpGenInt, lpDPRAMaddress, lpPCTC1);//set gen interupt
      AEC_PCTC_SEND_COMMAND(lpstuffTCgen, lpAECstrA, lpPCTC1); //stuff tcgen
      AEC_PCTC_SEND_COMMAND(lprunLTCnGEN, lpAECstrA, lpPCTC1); //run LTC & Gen
      AEC_PCTC_SEND_COMMAND(lpstartGen,	lpAECstrA, lpPCTC1); //start Gen
      ckvltc = AEC_PCTC_CHECK_BOARD(lpPCTC1);	// test board
      ckmmr = AEC_PCTC_CHECK_BOARD(lpMMR1);
      ckior = AEC_PCTC_CHECK_BOARD(lpIOR1);
      passed_address = AEC_PCTC_ECHO_ADDR(lpPCTC1);   //get address echo
      longbyte = (DWORD) passed_address;	//FORMAT ADDRESS FOR OUTPUT

      GetMessage (&msg, NULL, 0, 0);				// WO
    do
	{
	TranslateMessage (&msg) ;				// WO
	DispatchMessage (&msg) ;				// WO
	do
	    {
	    DPRAMaddress = 0x03FD;
	    AEC_PCTC_READ_1BYTE(lpAEC3fdReg, lpDPRAMaddress, lpPCTC1);
		      // see if DPRAM address 0x03FD has changed
	    if ( AEC3fdReg != 0x00 )
		{
		Cmdbyte = 50;
		AEC_PCTC_GET_INTCODE(lpCmdbyte, lpAEC3feReg, lpPCTC1);

		if ( AEC3feReg == 0x4C )
			{
			DPRAMaddress = 0x0050;
		   AEC_PCTC_READ_4BYTES(lpAECREAD4, lpDPRAMaddress, lpPCTC1);
			Cmdbyte = 0x01;
			AEC_PCTC_DWORD_TO_STR(lpCmdbyte, lpAECREAD4, lpAEChhmmssff);

			aecnum1 = AEC_PCTC_READ_ASC_TB(lpAECascTB, lpPCTC1);
			aecnum2 = AEC_PCTC_READ_ASC_UB(lpAECascUB, lpPCTC1);
			AEC_PCTC_READ_TB(lpAECTB, lpPCTC1);
			AEC_PCTC_READ_TBE(lpAECTBE, lpPCTC1);
			AEC_PCTC_READ_UB(lpAECUB, lpPCTC1);
			InvalidateRect ( hwnd, NULL, 0 );
				// makes Windows update screen changes
			}
		}
	    }
	while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)));
	    // look for any messages (allows Windows access to polling loop)
	}
    while (GetMessage (&msg, NULL, 0, 0));
	    // if message is not the WM_QUIT message continue in loop

    AEC_PCTC_UNINSTALL_BOARD(lpPCTC1); // Removes & Frees the given selector
    TranslateMessage (&msg) ;					// WO
    DispatchMessage (&msg) ;					// WO
    return msg.wParam ; 					// WO
    }

/********************************************************************/

long FAR PASCAL _export WndProc (HWND hwnd, UINT message, UINT wParam,
                                                          LONG lParam)
     {
     HDC	     hdc;					// WO
     PAINTSTRUCT     ps;					// WO
     RECT	     rect;					// WO

     switch (message)						// WO
          {
	  case WM_PAINT:					// WO
	       hdc = BeginPaint (hwnd, &ps) ;			// WO
	       GetClientRect (hwnd, &rect) ;			// WO

    //ALL THE 'DrawText' CODE ITEMS BELOW FORMAT THE OUTPUT TO THE WINDOW
	       DrawText (hdc,
		       AEChhmmssff,
		       -1,
		       &rect,
		       DT_SINGLELINE | DT_CENTER | DT_VCENTER);
			 /* formats text in center of window */
	       DrawText (hdc,
		       hhmmssff,
		       wsprintf (hhmmssff,"%d %d %d",
			  ckvltc, ckmmr, ckior),
		       &rect,
		       DT_SINGLELINE);
			 /* formats text in upper-left of window */

	       DrawText (hdc,
		       hhmmssff,
		       wsprintf (hhmmssff,"%04lX",
		       longbyte),
		       &rect,
		       DT_SINGLELINE | DT_VCENTER);
			 /* formats text in center-left of window */
	       DrawText (hdc,
		       hhmmssff,
		       wsprintf (hhmmssff,"%lX",
			  AECTB),
		       &rect,
		       DT_SINGLELINE | DT_RIGHT);
			 /* formats text in upper-right of window */
	       DrawText (hdc,
		       hhmmssff,
		       wsprintf (hhmmssff,"%lX",
			  AECTBE),
		       &rect,
		       DT_SINGLELINE | DT_VCENTER | DT_RIGHT);
		       // formats text in vertical center-right side of window
	       DrawText (hdc,
		       hhmmssff,
		       wsprintf (hhmmssff,"%lX",
			  AECREAD4),
		       &rect,
		       DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);
			/* formats text in bottom-right of window */
	       DrawText (hdc,
		       AECascUB,
		       -1,
		       &rect,
		       DT_SINGLELINE | DT_BOTTOM | DT_CENTER);
			/* formats text in bottom-center of window */
	       DrawText (hdc,
		       AECascTB,
		       -1,
		       &rect,
		       DT_SINGLELINE | DT_CENTER);
			/* formats text in top-center of window */

	       DrawText (hdc,
		       rev,
		       aecint,
		       &rect,
		       DT_SINGLELINE | DT_BOTTOM);
			/* formats text in bottom-left of window */
	       EndPaint (hwnd, &ps) ;				// WO
	       return 0 ;					// WO

	  case WM_DESTROY:					// WO
	       PostQuitMessage (0) ;				// WO
	       return 0 ;					// WO
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	// WO
     }
/********************************************************************/
		// END OF CODE	  END OF CODE	  END OF CODE
