/*--------------------------------------------------------
   X_APP3.C -- Displays " hh:mm:ss:ff" in client area
  --------------------------------------------------------*/
    //NOTE: WHERE THERE IS A 'WO' IN THE COMMENTS BELOW, IT STANDS FOR
		// 'WINDOWS OVERHEAD'. THE 'WO' CODE HELPS TO DRAW THE
		// WINDOW, UPDATE THE WINDOW, ETC.

#include <windows.h>
#include "aecdll.h"	      //PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS

//VARIABLE DEFINITIONS
char	hhmmssff[11];
int	aecint, aecnum1, aecnum2, loopint, ckvltc, ckmmr, ckior;
char	rev[2], AECstrA[2], AECascTB[12], AECascUB[12], AEChhmmssff[12];
WORD	PCTC1, MMR1, IOR1, DPRAMaddress, passed_address, AECselector;
BYTE	ResetBrd, idleMode, stuffTCgen, runLTCnGEN, startGen, stopGen;
BYTE	GenInt, AEC3fdReg, AEC3feReg, AECREAD1, AECWRITE1, AECCOMMAND;
BYTE	breakup[4], Cmdbyte;
DWORD	AECTB, AECTBE, AECUB, AECREAD4, AECWRITE4, longbyte, long8to4;
LPSTR	lpPassToAECDLLrev, lpAEChhmmssff;     /* typedef char FAR* LPSTR */
LPSTR	lpAECascTB, lpAECascUB, lpAECstrA;
LPWORD	lpAECselector, lpPCTC1, lpMMR1, lpIOR1, lpDPRAMaddress; /* typedef word FAR* LPWORD */
LPBYTE	lpAECREAD1, lpAECWRITE1, lpAECCOMMAND, lpCmdbyte;
LPBYTE	lpGenInt, lpAEC3fdReg, lpAEC3feReg, lpbreak;
LPDWORD lpAECTB, lpAECTBE, lpAECUB, lpAECREAD4, lpAECWRITE4;//dword FAR* DWORD

long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;
	    /*window proceedure (WndProc) PROTOTYPE*/
/************************************************************************/

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
    {
    static char szAppName[] = "TIME CODE" ;			// WO
    HWND	 hwnd ; 					// WO
    WNDCLASS	 wndclass ;					// WO
    MSG		 msg;						// WO

    lpPassToAECDLLrev = rev;		   // set and initialize variables
    lpAECascTB = AECascTB;				   //
    lpAECascUB = AECascUB;				   //
    lpAECstrA  = AECstrA;				   //
    lpAEChhmmssff = AEChhmmssff;			   //
    lpAECselector = &AECselector;			   //
    PCTC1  =  0xCC00;		// PCTC Board base address
    lpPCTC1 = &PCTC1;					   //
    lpCmdbyte = &Cmdbyte;
    MMR1 = 0xC800;
    lpMMR1 = &MMR1;
    IOR1 =0x02A0;
    lpIOR1 = &IOR1;
    ResetBrd	 = 0x02;	// PCTC command codes
    idleMode	 = 0x20;		  //
    stuffTCgen	 = 0x41;		  //
    runLTCnGEN	 = 0x25;		  //
    startGen	 = 0x48;		  //
    stopGen	 = 0x49;		  //
    GenInt   = 0x04;					    //
    lpAECREAD1 = &AECREAD1;
    lpAECWRITE1 = &AECWRITE1;
    lpAECCOMMAND = &AECCOMMAND;
    lpDPRAMaddress = &DPRAMaddress;			    //
    lpGenInt	= &GenInt;				    //
    lpAEC3fdReg = &AEC3fdReg;				    //
    lpAEC3feReg = &AEC3feReg;				    //
    lpAECTB	= &AECTB;				    //
    lpAECTBE	= &AECTBE;				    //
    lpAECUB	= &AECUB;				    //
    lpAECREAD4	= &AECREAD4;				    //
    lpAECWRITE4 = &AECWRITE4;				    //
    AECWRITE4	= 0x23593512; //'Hex' STUFF GEN DATA 23:59:05:12 HH:MM:SS:FF

    if (!hPrevInstance) // WO used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		// WO
	  wndclass.lpfnWndProc	 = WndProc ;				// WO
	  wndclass.cbClsExtra	 = 0 ;					// WO
	  wndclass.cbWndExtra	 = 0 ;					// WO
	  wndclass.hInstance	 = hInstance ;				// WO
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	// WO
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	// WO
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	// WO
	  wndclass.lpszMenuName  = NULL ;				// WO
	  wndclass.lpszClassName = szAppName ;				// WO

	  RegisterClass (&wndclass) ;					// WO
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, // ext. window style(always on top)
		    szAppName,		 // address of registered class name
		    "AECPC-TC Demo3",		     // window text
		    WS_DLGFRAME | WS_SYSMENU,	     // window style
		    0x30,			     // initial x position
		    0x10,			     // initial y position
		    0x150,			     // window width
		    0x1A0,			     // window height
                    NULL,                    // parent window handle
                    NULL,                    // window menu handle
                    hInstance,               // program instance handle
		    NULL) ;		     // creation parameters
    ShowWindow (hwnd, nCmdShow) ;	// WO part of the window creation
    AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);	// GET DLL VERSION INFO
    loopint = 0x1E;   // loop variable used to speed up the window updates
    UpdateWindow (hwnd) ;		// WO part of the window creation

	// THE FOLLOWING CODE BLOCK INITIALIZES THE BOARD AND STARTS THE GEN
    AEC_PCTC_GET_SELECTOR(lpAECselector, lpPCTC1); // put the board's selector
		//  in data word at the address pointed to by the far pointer
    AECCOMMAND = ResetBrd;
    AEC_PCTC_SEND_COMMAND(lpAECCOMMAND, lpAECstrA, lpPCTC1); // resets board
    AECCOMMAND = idleMode;
    AEC_PCTC_SEND_COMMAND(lpAECCOMMAND, lpAECstrA, lpPCTC1); //send idle code
    DPRAMaddress = 0x0040;  //*sets the time that gen will use when started
    AEC_PCTC_WRITE_4BYTES(lpAECWRITE4, lpDPRAMaddress, lpPCTC1);
    DPRAMaddress = 0x03F0;	// sets tc generator frame change interupt
    AECWRITE1 = GenInt;
    AEC_PCTC_WRITE_1BYTE(lpAECWRITE1, lpDPRAMaddress, lpPCTC1);//set gen interupt
    AECCOMMAND = stuffTCgen;
    AEC_PCTC_SEND_COMMAND(lpAECCOMMAND, lpAECstrA, lpPCTC1); //stuff tcgen
    AECCOMMAND = runLTCnGEN;
    AEC_PCTC_SEND_COMMAND(lpAECCOMMAND, lpAECstrA, lpPCTC1); //run LTC & Gen

    ckvltc = AEC_PCTC_CHECK_BOARD(lpPCTC1);	// test board
    ckmmr = AEC_PCTC_CHECK_BOARD(lpMMR1);
    ckior = AEC_PCTC_CHECK_BOARD(lpIOR1);

    AECCOMMAND = startGen;
    AEC_PCTC_SEND_COMMAND(lpAECCOMMAND,	lpAECstrA, lpPCTC1); //start Gen
    passed_address = AEC_PCTC_ECHO_ADDR(lpPCTC1);	//get address echo
    long8to4 = (DWORD) passed_address;	//convert address for printing

    GetMessage (&msg, NULL, 0, 0);				// WO
    do
	{
	TranslateMessage (&msg) ;				// WO
	DispatchMessage (&msg) ;				// WO
	do
	    {

	    DPRAMaddress = 0x03FD;
	    AEC_PCTC_READ_1BYTE(lpAEC3fdReg, lpDPRAMaddress, lpPCTC1);
		      // see if DPRAM address 0x03FD has changed
	    if ( AEC3fdReg != 0x00 )
		{
//		Cmdbyte = 50;
		Cmdbyte = 0;
		AEC_PCTC_GET_INTCODE(lpCmdbyte, lpAEC3feReg, lpPCTC1);

		if ( AEC3feReg == 0x4C )
			{
			DPRAMaddress = 0x0050;
		   AEC_PCTC_READ_4BYTES(lpAECREAD4, lpDPRAMaddress, lpPCTC1);
			Cmdbyte = 0x01;
			AEC_PCTC_DWORD_TO_STR(lpCmdbyte, lpAECREAD4, lpAEChhmmssff);
			aecnum1 = AEC_PCTC_READ_ASC_TB(lpAECascTB, lpPCTC1);
			aecnum2 = AEC_PCTC_READ_ASC_UB(lpAECascUB, lpPCTC1);
			AEC_PCTC_READ_TB(lpAECTB, lpPCTC1);

			  // The following can be used to break up
			      // a double word (4bytes) into 4 separate
			      // pieces of data. It is done by casting the
			      // pointer (&AECTB or other) into a pointer
			      // that points to a byte. Then each element
			      // of the DWORD is stored in an array of bytes.
			lpbreak = (LPBYTE) &AECTB; // change pointer (by CAST)
			breakup[0] = *(lpbreak + 0x0);	// store the ff byte
			breakup[1] = *(lpbreak + 0x1);	// store the ss byte
			breakup[2] = *(lpbreak + 0x2);	// store the mm byte
			breakup[3] = *(lpbreak + 0x3);	// store the hh byte

			AEC_PCTC_READ_TBE(lpAECTBE, lpPCTC1);
			AEC_PCTC_READ_UB(lpAECUB, lpPCTC1);

			loopint = loopint + 1;	// increment loop count.
			   // the loop is used to keep the entire window from
			   // redrawing each time the time code is updated.

			InvalidateRect ( hwnd, NULL, 0 );
				// makes Windows update screen changes
			}
		}
	    }
	while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)));
	    // look for any messages (allows Windows access to polling loop)
	}
    while (GetMessage (&msg, NULL, 0, 0));
	    // if message is not the WM_QUIT message continue in loop

    AEC_PCTC_UNINSTALL_BOARD(lpPCTC1); // Removes & Frees the given selector
    TranslateMessage (&msg) ;					// WO
    DispatchMessage (&msg) ;					// WO
    return msg.wParam ; 					// WO
    }

/********************************************************************/

long FAR PASCAL _export WndProc (HWND hwnd, UINT message, UINT wParam,
                                                          LONG lParam)
     {
     HDC	     hdc;					// WO
     PAINTSTRUCT     ps;					// WO
     RECT	     rect;					// WO

     switch (message)						// WO
          {
	  case WM_PAINT:					// WO
	       hdc = BeginPaint (hwnd, &ps) ;			// WO
	       GetClientRect (hwnd, &rect) ;			// WO

//NOTE:  THE 'TextOut' CODE ITEMS BELOW FORMAT THE DATA FOR DISPLAY IN WINDOW

	    if ( loopint >= 0x1E )
		{
	       loopint = 0;	// the loopint variable is incremented once
				  // each time the frame data changes
				  // the 0x1E makes about a 1 sec. update
				  // cycle period for the 'non-changing' text
				  // ie: update once in a while.
	       //header
	       TextOut (hdc, 29, 10, "Sample Program Using the AECPC-TC.DLL", 37);
	       TextOut (hdc, 29, 28, "The Returned/Sent bytes are shown below.", 40);

	       // 1 READ_TB
	       TextOut (hdc, 5, 50, "Selected Time Bits (READ_TB)", 28);
	       // 1 READ_TB  (UNPACKERD)
	       TextOut (hdc, 5, 70, "(READ_TB) HH:", 13);
	       TextOut (hdc, 140, 70, "MM:", 3);
	       TextOut (hdc, 210, 70, "SS:", 3);
	       TextOut (hdc, 280, 70, "FF:", 3);

	       // 2 READ_TBE
	       TextOut (hdc, 5, 90, "Selected Time Bits (READ_TBE)", 29);
	       // 3 READ_UB
	       TextOut (hdc, 5, 110, "Selected User Bits (READ_UB)", 28);
	       // 4 READ_ASC_TB
	       TextOut (hdc, 5, 130, "Selected Time (READ_ASC_TB)", 27);
	       // 5 READ_ASC_UB
	       TextOut (hdc, 5, 150, "Selected Time (READ_ASC_UB)", 27);
	       // 6 READ_DPRAM
	       TextOut (hdc, 5, 170, "Read a byte (READ_1BYTE)", 24);
	       // 6A READ_DPRAM_4
	       TextOut (hdc, 5, 190, "Read 4 bytes (READ_4BYTES)", 26);
	       // 7 WRITE_DPRAM
	       TextOut (hdc, 5, 210, "Write a byte (WRITE_1BYTE)", 26);
	       // 7A WRITE_DPRAM_4
	       TextOut (hdc, 5, 230, "Write 4 bytes (WRITE_4BYTES)", 28);
	       TextOut (hdc, 240, 230, hhmmssff,
		       wsprintf (hhmmssff,"%08lX",  AECWRITE4));
	       // 8 GET_INTCODE
	       TextOut (hdc, 5, 250, "Current intcode (GET_INTCODE)", 29);
	       // 9 SEND_COMMAND
	       TextOut (hdc, 5, 270, "Last command (SEND_COMMAND)", 27);
	       // 10 GET_DLL_INFO
	       TextOut (hdc, 5, 290, "DLL Version (GET_DLL_INFO)", 26);
	       TextOut (hdc, 240, 290,	rev, 2);
	       // 11 GET_SELECTOR
	       TextOut (hdc, 5, 310, "Board's Selector (GET_SELECTOR)", 31);

	       longbyte = (DWORD) AECselector;
	       TextOut (hdc, 240, 310, hhmmssff,
		       wsprintf (hhmmssff,"%04lX",  longbyte));
	       // 12  UNINSTALL used when the program is ending
	       // 13 DWORD_TO_STR
	       TextOut (hdc, 5, 330, "Upack 4 Bytes (DWORD_TO_STR)", 28);
	       // 14 CHECK_BRD
	       TextOut (hdc, 5, 350, "BOARD TYPES (CHECK_BOARD)", 25);
	       // 15 GET ADDRESS ECHO
	       TextOut (hdc, 5, 370, "ECHO ADDRESS",12);


		}
	    // ALWAYS UPDATE THE FOLLOWING ITEMS EACH TIME THE WINDOW IS
	    // REPAINTED.
	       //1
	       TextOut (hdc, 240, 50, hhmmssff,
		       wsprintf (hhmmssff,"%08lX",  AECTB));
	       // 1 UNPACKED
		longbyte = (DWORD) breakup[3];
		TextOut (hdc, 108,70, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
		longbyte = (DWORD) breakup[2];
		TextOut (hdc, 170,70, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
		longbyte = (DWORD) breakup[1];
		TextOut (hdc, 235,70, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
		longbyte = (DWORD) breakup[0];
		TextOut (hdc, 305,70, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
	       // 2
	       TextOut (hdc, 240, 90, hhmmssff,
		       wsprintf (hhmmssff,"%08lX",  AECTBE));
	       // 3
	       TextOut (hdc, 240, 110, hhmmssff,
		       wsprintf (hhmmssff,"%08lX",  AECUB));
	       // 4
	       TextOut (hdc, 240, 130, AECascTB, 11);
	       // 5
	       TextOut (hdc, 240, 150, AECascUB, 11);
	       // 6
	       longbyte = (DWORD) AEC3fdReg;
	       TextOut (hdc, 240, 170, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
	       // 6A
	       TextOut (hdc, 240, 190, hhmmssff,
		       wsprintf (hhmmssff,"%08lX",  AECREAD4));
	       // 7
	       longbyte = (DWORD) AECWRITE1;
	       TextOut (hdc, 240, 210, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
	       // 8
	       longbyte = (DWORD) AEC3feReg;
	       TextOut (hdc, 240, 250, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
	       // 9
	       longbyte = (DWORD) AECCOMMAND;
	       TextOut (hdc, 240, 270, hhmmssff,
		       wsprintf (hhmmssff,"%02lX",  longbyte));
	       // 13
	       TextOut (hdc, 240, 330, AEChhmmssff, 11);
	       // 14
	       TextOut (hdc, 240, 350, hhmmssff,
		       wsprintf (hhmmssff,"%01d  %01d  %01d",
			  ckvltc, ckmmr, ckior));
	       // 15 GET ADDRESS ECHO
	       TextOut (hdc, 240, 370, hhmmssff,
		       wsprintf (hhmmssff,"%04lX", long8to4));

	       EndPaint (hwnd, &ps) ;				// WO
	       return 0 ;					// WO

     //********************************************
	  case WM_DESTROY:					// WO
	       PostQuitMessage (0) ;				// WO
	       return 0 ;					// WO
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	// WO
     }
/********************************************************************/
	     // END OF CODE    END OF CODE     END OF CODE
